// DAIVA (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	char fname[256];
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i;
	unsigned char id[] = "DAIVA       Sys ";

	struct fpos md[] =
	{
		{ "OP",   0x01, 0x01, 0x8800 },
		{ "MAIN", 0x18, 0x02, 0x0800 },
		{ "SUB",  0x3b, 0x01, 0x1500 },
		{ "ED",   0x4a, 0x0c, 0x3f00 },
		{ "",     0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x13);
		// ȃf[^̕ŃfBXN𔻒
		if (!memcmp(&buff[2], id, sizeof(id)-1))
		{
			printf("DISK AF܂.\n");
			// ȃf[^vO
			for (i=0; md[i].sec; i++)
			{
				fcut(md[i].fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
			}
		}
	}
	return 0;
}

